
(*

      Operations in the field Z/pZ, p=31991.

      Loic Pottier.

*)

let prime = 31991
;;
let prime2=prime/2;;

let ri x = let y = (if x>=0 then x mod prime else (prime + (x mod prime))) in
           if y>=prime2  then (y- prime) else y;;

let eq_coef x y = (x=y);;
let lt_coef x y = (x<y);;
let abs_coef x = x;;
let pluscoef x y = ri (x+y);;
let multcoef x y = ri (x*y);;
let subcoef x y = ri (x-y);;
let oppcoef x = ri (-x);;

(* bezout *)

let rec bezoutrec (x,a,b,y,a',b') =
   let z = y mod x in
   let c = y/x in
   if z=0
   then (b,a)
   else bezoutrec (z, a'-c*a, b'-c*b,x,a,b)
;;

(* 
   rend a et b tels que ax+by=pgcd(x,y)
   est-ce qu'on a toujours a<y et b<x???
*)

let bezout x y = bezoutrec (x,0,1,y,1,0);; 

let invmemo = Array.create 31991 0;;

let invmod x = 
  let y = x+prime2+1 in
  let v = invmemo.(y) in
  if v<>0 
  then v
  else (let i=(if x>= 0 
               then (let (a,b) = bezout prime x in (ri b))
               else (let (a,b) = bezout prime (-x) in (ri (-b)))) in
        invmemo.(y)<- i;
        i)
;;
       
let divcoef x y = let r = ri (x*(invmod y)) in r
;;

let coef0 = (ri 0);;
let coef1 = (ri 1);;

let string_of_coef r = string_of_int r;;

